;----------------------------------------------------------------------------
; Torus Demo 1.1 - by Jimmy Mardell <mja@algonet.se>
;
; Fargo II conversion by David Ellsworth <davidell@earthling.net>
; 92+ conversion by Kty
; Prosit conversion by Kty <kty@mailcity.com>
; Slightly modified by Prefect <e96nbr@efd.lth.se>
;----------------------------------------------------------------------------

	include		"calc.h"

        include		"doorsos.h"
	include		"macros.h"
	include		"hexlib.h"
	include		"prosit.h"
	include		"winlib.h"
	include		"keycodes.h"

	xdef		_prosit
	xdef    	_main
	xdef		_exit
	xdef		_comment

WordWidth		EQU	14
nopoints		EQU	179
nolines			EQU	nopoints*2

SQUARES_Y               EQU     14
STR_FLAGS_1		EQU	F_NORMAL
STR_FONT_1		EQU	0

WIN1_W                  EQU     112
WIN1_H                  EQU     97
WIN1_X                  EQU     (SCREEN_WIDTH-WIN1_W)/2
WIN1_Y                  EQU     0

TORUS_X_CENTER		EQU	66
TORUS_Y_CENTER		EQU	43

BUTTONS                 EQU     8
BUT_W                   EQU     12
BUT_W2                  EQU     21
BUT_H			EQU	9
BUT_S			EQU	BUT_H+1


_prosit:
	HEADER_BEGIN
	DEFINE_PROSIT_VERSION	PROSIT_VERSION_STRING
	DEFINE_PROSIT_FILETYPE	PROSIT_FILETYPE_PROGRAM
	DEFINE_PROSIT_STACKSIZE	1024
	DEFINE_PROSIT_EVENT	"moub",Event_Mousebutton
	DEFINE_PROSIT_EVENT	"quit",Event_Quit
	HEADER_END

_main:
	move.b		#0,Window+W_FLAGS
	move.b		#0,Window+W_PRIORITY
	pea		window1(pc)			;*Structure
	move.l		#Window_Datareturn,-(sp)	;*Return
	pea		winrect(pc)			;*Window dimensions
	move.l		#Window,-(sp)			;*Window
	jsr		winlib::WinOpen
	lea		16(sp),sp

	move.w		Window+W_CONTENTS_HANDLE,d0
	doorsos::DEREF	d0,a6

	clr.w		frames		;Clear the frame counter
	adda.l		#4+7*WordWidth,a6	;Jump down below the title bar
	move.l		a6,vscr		;Store the gfx buffer pointer
	move.l		#$19202200,vx	;Set start angles and mode
	move.b		#$00,dispmode	;Set pixel mode

\auto	addq.b		#4,vx
	addq.b		#5,vy
	addq.b		#6,vz
\plot	bsr		Calc3D
	bsr		DrawTorus
	bsr		IncFrame
	move.l		#Window,-(sp)
	jsr		winlib::Refresh_Window
	addq.l		#4,sp
	tst.b		mode
	beq.s		\auto		;Automatic mode, keep updating
	jsr		Prosit::Sleep	;Manual mode, go to sleep and wait for user input
	bra.s		\plot

;*******************************************************

IncFrame:
	addq.w		#1,frames
	clr.l		d0

	move.w		frames,d0
	lea		strend,a0
	clr.b		-(a0)
	moveq		#4,d1
RepConv:
	divu		#10,d0
	move.l		d0,d2
	swap		d2
	add.b		#48,d2
	move.b		d2,-(a0)
	and.l		#$FFFF,d0
	dbra		d1,RepConv
	move.b		#A_NORMAL,Window+W_TEXT_LINE_ATTRIBUTES
	move.l		a0,-(sp)			;*String
	move.w		#8,-(sp)			;Y
	move.w		#WIN1_W-22,-(sp)		;X
	move.l		#Window,-(sp)
	jsr		doorsos::WinStrXY
	lea		12(sp),sp

	rts

;*******************************************************

DrawTorus:
	move.l		vscr,a0
	move.w		#87,d0
RepClr:
	and.l		#%11111111111111111111111100000000,(a0)+
	clr.l		(a0)+
	clr.l		(a0)+
	and.w		#%0000000000000001,(a0)+
	dbra		d0,RepClr

	move.l		vscr,a0
	lea		dotc,a1
	tst.b		(dispmode)
	bne		DrawPoints
	lea		lines(PC),a2
	move.l		#nolines,d7
RepDrawLines:
	clr.w		d5
	clr.w		d6
	move.b		(a2)+,d5	;Point #1
	move.b		(a2)+,d6	;Point #2
	lsl.w		#2,d5
	lsl.w		#2,d6
	move.w		0(a1,d5),d0	;X1
	move.w		2(a1,d5),d1	;Y1
	move.w		0(a1,d6),d2	;X2
	move.w		2(a1,d6),d3	;Y2
	bsr		Fline
\next	dbra		d7,RepDrawLines
	rts

DrawPoints:
	move.l		#nopoints,d7
RepDrawPoints:
	move.w		(a1)+,d0	;X
	move.w		(a1)+,d4	;Y
	move.w		d4,d5
	lsl.w		#4,d4		;5
	lsl.w		#1,d5		;1
	sub.w		d5,d4
	move.w		d0,d5
	lsr.w		#3,d5
	add.w		d5,d4
	move.w		d0,d5
	not		d5
	and.b		#$07,d5
	bset.b		d5,0(a0,d4)
	dbra		d7,RepDrawPoints
	rts

;*******************************************************

Calc3D:
	lea		points(PC),a0
	lea		sintable+$80(PC),a1
	lea		sintable(PC),a2
	lea		dotc,a6
	move.l		#nopoints,d7
RepPoints:
	move.l		d7,-(a7)
	move.w		(a0)+,d0
	ext.l		d0
	move.w		(a0)+,d1
	ext.l		d1
	move.w		(a0)+,d2
	ext.l		d2

	clr.l		d3
	move.b		vy,d3
	lsl		#1,d3
	move.w		0(a1,d3),d4	; d4=yc
	move.w		0(a2,d3),d5	; d5=ys
	ext.l		d4
	ext.l		d5

	move.l		d0,d6
	muls		d4,d6		; d6=x*yc
	move.l		d2,d7
	muls		d5,d7		; d7=ys*z
	sub.l		d7,d6
	asr.l		#8,d6
	asr.l		#4,d6
	move.l		d6,a3		; a3=(yc*x-ys*z)/factor (xt)
	move.l		d0,d6
	muls		d5,d6
	move.l		d2,d7
	muls		d4,d7
	add.l		d6,d7
	asr.l		#8,d7
	asr.l		#4,d7
	move.l		d7,a4		; a4=(ys*x+yc*z)/factor (zt)

	clr.l		d3
	move.b		vz,d3
	lsl		#1,d3
	move.w		0(a1,d3),d4	; d4=zc
	move.w		0(a2,d3),d5	; d5=zs

	move.l		a3,d6
	muls		d4,d6
	move.l		d1,d7
	muls		d5,d7
	add.l		d6,d7
	asr.l		#8,d7
	asr.l		#4,d7
	move.l		d7,d0		; d0=(zc*xt+zs*y) DIV faktor (x)
	move.l		d1,d6
	muls		d4,d6
	move.l		a3,d7
	muls		d5,d7
	sub.l		d7,d6
	asr.l		#8,d6
	asr.l		#4,d6
	move.w		d6,a5		; a5=(zc*y-zs*xt) DIV faktor (yt)

	clr.l		d3
	move.b		vx,d3
	lsl		#1,d3
	move.w		0(a1,d3),d4	; d4=xc
	move.w		0(a2,d3),d5	; d5=xs

	move.l		a4,d6
	muls		d4,d6
	move.l		a5,d7
	muls		d5,d7
	sub.l		d7,d6
	asr.l		#8,d6
	asr.l		#4,d6
	move.l		d6,d2		; d2=(xc*zt-xs*yt) DIV faktor (z)
	move.l		a5,d6
	muls		d4,d6
	move.l		a4,d7
	muls		d5,d7
	add.l		d6,d7
	asr.l		#8,d7
	asr.l		#4,d7
	move.l		d7,d1		; d1=(xs*zt+xc*yt) DIV faktor (y)

	sub.w		#1024,d2
	beq		DivZero
	lsl.l		#8,d0
	lsl.l		#2,d0
	move.l		d0,d4
	divs		d2,d4
	ext.l		d4
	add.l		#TORUS_X_CENTER,d4	;Move X out to middle of window
	lsl.l		#8,d1
	lsl.l		#2,d1
	move.l		d1,d5
	divs		d2,d5
	ext.l		d5
	add.l		#TORUS_Y_CENTER,d5	;Move Y out to middle of window
	bra		PutPoint
DivZero:
	move.l		#TORUS_X_CENTER,d4
	move.l		#TORUS_Y_CENTER,d5
PutPoint:
	move.w		d4,(a6)+	;Finished X
	move.w		d5,(a6)+	;Finished Y
	move.l		(a7)+,d7
	dbra		d7,RepPoints

	rts

;*******************************************************
Fline:                                          ;Thx to Jimmy Mardell
	movem.l		d0-d7/a0,-(a7)
	cmp.w		d0,d2
	bcc		DXpos
	exg		d0,d2
	exg		d1,d3
DXpos:
	move.w		d1,d4
	move.w		d1,d5
	lsl.w		#4,d4		;5
	lsl.w		#1,d5		;1
	sub.w		d5,d4
	move.w		d0,d5
	lsr.w		#3,d5
	add.w		d5,d4
	move.w		d0,d5
	not		d5
	and.b		#$07,d5
	adda		d4,a0
	bset.b		d5,(a0)
	move.b		d5,d6
	moveq		#1,d5
	lsl		d6,d5
	move.w		d2,d6
	sub.w		d0,d6
ChY:
	cmp.w		d1,d3
	bcc		DYpos
	moveq		#-WordWidth,d4
	move.w		d1,d7
	sub.w		d3,d7
	bra		PutP1
DYpos:
	moveq		#WordWidth,d4
	move.w		d3,d7
	sub.w		d1,d7
PutP1:					; d4 = YAI, d5 = bit, d6 = DX, d7 = DY, A0 = Ptr
	cmp.w		d0,d2
	bne		DotsNE
	cmp.w		d1,d3
	beq		LineDone
DotsNE:
	cmp.w		d6,d7
	bcc		DY_Greater
	move.l		d6,d2
	subq		#1,d2		; d2 = number of pixels to be plot
	move.w		d7,d3
	sub.w		d6,d3		; d3 = dy-dx
	asl.w		#1,d3		; d3 = ai
	lsl.w		#1,d7		; d7 = bi
	sub.w		d7,d6
	neg		d6		; d6 = d
RepX:
	or.w		d6,d6
	bmi		X_DNeg
	adda		d4,a0
	add.w		d3,d6
	bra		IncX
X_DNeg:
	add.w		d7,d6
IncX:
	ror.b		#1,d5
	bcc		X_SameByte
	addq		#1,a0
X_SameByte:
	or.b		d5,(a0)
	dbra		d2,RepX
	bra		LineDone
DY_Greater:
	move.l		d7,d3
	subq		#1,d3		; d3 = number of pixels to be plot
	move.w		d6,d2
	sub.w		d7,d2		; d2 = dx-dy
	lsl.w		#1,d2		; d2 = ai
	lsl.w		#1,d6		; d6 = bi
	sub.w		d6,d7
	neg		d7		; d7 = d
RepY:
	or.w		d7,d7
	bmi		Y_DNeg
	ror.b		#1,d5
	bcc		Y_SameByte
	addq		#1,a0
Y_SameByte:
	add.w		d2,d7
	bra		IncY
Y_DNeg:
	add.w		d6,d7
IncY:
	adda		d4,a0
	or.b		d5,(a0)
	dbra		d3,RepY
LineDone:
	movem.l		(a7)+,d0-d7/a0
	rts

;*******************************************************

Event_Mousebutton:
	movem.l		d0,-(sp)
	move.w		MouseButton,d0
	tst.b		mode
	beq.s		\auto		;Automatic mode, ignore buttons 1-6
	cmp.w		#1,d0
	beq.s		\xp
	cmp.w		#2,d0
	beq.s		\xm
	cmp.w		#3,d0
	beq.s		\yp
	cmp.w		#4,d0
	beq.s		\ym
	cmp.w		#5,d0
	beq.s		\zp
	cmp.w		#6,d0
	bne.s		\auto

;Decrease Z
\zm	subq.b		#5,vz
	bra.s		\done
;Increase X
\xp	addq.b		#5,vx
	bra.s		\done
;Decrease X
\xm	subq.b		#5,vx
	bra.s		\done
;Increase Y
\yp	addq.b		#5,vy
	bra.s		\done
;Decrease Y
\ym	subq.b		#5,vy
	bra.s		\done
;Increase Z
\zp	addq.b		#5,vz
	bra.s		\done

\auto	cmp.w		#7,d0
	beq.s		\mode
	cmp.w		#8,d0
	bne.s		\done
;Pixel Mode
	bchg.b		#0,dispmode	;Switch pixel mode
	bra.s		\done

;Program Mode (Demo / User)
\mode	bchg.b		#0,mode		;Switch mode

\done	movem.l		(sp)+,d0
	rts

;*******************************************************

_exit:
Event_Quit:
	move.l		#Window,-(sp)
	jsr		winlib::WinClose
	move.w		Prosit::CurrentProcessID,(sp)
	jsr		Prosit::Process_Terminate


;***********************************************************************

       EVEN
        dc.l    0
sintable:
        incbin "sint.bin"
     EVEN
points:
        incbin "t_points.bin"
     EVEN
lines:
        incbin "t_lines.bin"
;***********************************************************************

	EVEN
;WINDOW #1 STRUCTURE
window1:
lwgui	dc.l	w1gui	;Window GUI list
lwgotf	dc.l	w1foc	;"Window got focus" list
lwlostf	dc.l	w1nofoc	;"Window lost focus" list

;GUI LIST - FIRST ELEMENT
w1gui	dc.l	w1gui	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank

;GUI MANAGEMENT PART
	dc.l	w1gfx
	dc.l	w1bxp
	dc.w	1+RF_TRIG_FIRST+RF_TRIG_REPEAT
	dc.l	w1bxm
	dc.w	2+RF_TRIG_FIRST+RF_TRIG_REPEAT
	dc.l	w1byp
	dc.w	3+RF_TRIG_FIRST+RF_TRIG_REPEAT
	dc.l	w1bym
	dc.w	4+RF_TRIG_FIRST+RF_TRIG_REPEAT
	dc.l	w1bzp
	dc.w	5+RF_TRIG_FIRST+RF_TRIG_REPEAT
	dc.l	w1bzm
	dc.w	6+RF_TRIG_FIRST+RF_TRIG_REPEAT
	dc.l	w1bmode
	dc.w	7+RF_TRIG_RELEASE
	dc.l	w1bpl
	dc.w	8+RF_TRIG_RELEASE
	dc.l	0

;GUI GRAPHICAL PART
w1gfx	dc.b	R_RECT,0,0,0,WIN1_W-1,WIN1_H-1
	dc.w	A_NORMAL
w1bmode	dc.b    R_BUTTON,0,2,8,2+20,8+8
	dc.w	SMALL_TEXT_BUTTON
	dc.b	"Mode",0,0
w1bpl	dc.b    R_BUTTON,0,2,8+10,2+20,8+10+8
	dc.w	SMALL_TEXT_BUTTON
	dc.b	"L/D",0
w1bxp	dc.b    R_BUTTON,0,2,10+2*10,2+20,10+2*10+8
	dc.w	SMALL_TEXT_BUTTON
	dc.b	"X+",0,0
w1bxm	dc.b    R_BUTTON,0,2,10+3*10,2+20,10+3*10+8
	dc.w	SMALL_TEXT_BUTTON
	dc.b	"X-",0,0
w1byp	dc.b    R_BUTTON,0,2,13+4*10,2+20,13+4*10+8
	dc.w	SMALL_TEXT_BUTTON
	dc.b	"Y+",0,0
w1bym	dc.b    R_BUTTON,0,2,13+5*10,2+20,13+5*10+8
	dc.w	SMALL_TEXT_BUTTON
	dc.b	"Y-",0,0
w1bzp	dc.b    R_BUTTON,0,2,16+6*10,2+20,16+6*10+8
	dc.w	SMALL_TEXT_BUTTON
	dc.b	"Z+",0,0
w1bzm	dc.b    R_BUTTON,0,2,16+7*10,2+20,16+7*10+8
	dc.w	SMALL_TEXT_BUTTON
	dc.b	"Z-",0,0
	dc.b	-1


;"GOT FOCUS" LIST - FIRST ELEMENT
w1foc	dc.l	w1foc	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank
;"GOT FOCUS" MANAGEMENT PART
	dc.l	w1fgfx
	dc.l	w1fgfx
	dc.w	RF_QUIT+RF_TRIG_RELEASE
	dc.l	w1ft
	dc.w	-1
	dc.l	0
;"GOT FOCUS" GRAPHICAL PART
w1fgfx	dc.b	R_BUTTON,0,0,0,6,6
	dc.w	PL_CENTERED+BU_GFX+BU_FRAMED_BLACK+A_REPLACE
	dc.l	clopen,clclose
w1ft	dc.b	R_BUTTON,0,7,1,WIN1_W-2,6
	dc.w	PL_LEFT_TOP+BU_TEXT+BU_FILLED_BLACK+A_REVERSE+BU_SMALL_FONT
	dc.b	"Torus Demo",0,0
	dc.b	-1

;"LOST FOCUS" LIST - FIRST ELEMENT
w1nofoc	dc.l	w1nofoc	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank
;"LOST FOCUS" MANAGEMENT PART
	dc.l	w1lfgfx
	dc.l	0
;"LOST FOCUS" GRAPHICAL PART
w1lfgfx	dc.b	R_FILL,0,1,1,WIN1_W-2,5
	dc.w	A_XOR
	dc.b	-1

	EVEN
clopen	dc.w	5,5
	dc.b	%11111000
	dc.b	%10101000
	dc.b	%11011000
	dc.b	%10101000
	dc.b	%11111000
	EVEN
clclose	dc.w	5,5
	dc.b	%00000000
	dc.b	%01010000
	dc.b	%00100000
	dc.b	%01010000
	dc.b	%00000000


_comment
        dc.b    "Prosit: Torus",0

        EVEN
winrect	dc.w	WIN1_X,WIN1_Y,WIN1_X+WIN1_W-1,WIN1_Y+WIN1_H-1

	BSS
Window	ds.b	W_HEADER_SIZE

dotc	ds.l	nopoints+1

frames		dc.w	0

str		ds.b	6
strend

vscr		dc.l	0

vx		dc.b	0
vy		dc.b	0
vz		dc.b	0
mode		dc.b	0
dispmode	dc.b	0

	EVEN
Window_Datareturn:
Key		dc.w	0
MouseWindow	dc.w	0
MouseButton	dc.w	0
MouseX		dc.w	0
MouseY		dc.w	0
	CODE

	END
